#!/bin/sh

# disable filename globbing

 echo Content-type: text/plain
 echo
 BASE=`pwd`

T=./tmp/T
T1=./tmp/T1
T2=./tmp/T2
T3=./tmp/T3
./get >$T
ENC=./tmp/ENC
APPLDIR=$BASE/appl
DATADIR=$BASE/data
PATH=$PATH:$BASE/ihd/bin:.
TZ=America/Santiago
export PATH APPLDIR DATADIR TZ
        COMMAND=`awk -F= ' BEGIN {exit } END { printf "./ihd/bin/ihmu facturadeventa %s -N1\n","'"$T3"'" } ' `
        awk -F= ' $2=="" { next }
        /facturadeventaF/ { printf "H%s%s\n",substr($1,length($1)-1),substr($0,length($1)+2) }
        /facturadeventaH/ { printf "H%s%s\n",substr($1,length($1)-1),substr($0,length($1)+2) }
        /facturadeventaD/ { printf "D%s%s\n",substr($1,length($1)-3),substr($0,length($1)+2) }
        END { print " " }
        ' $T > $T3
        $COMMAND

awk -F= '
$0=="" || substr($1,1,1)=="T" || /DOCfacturadeventa/ || $1=="scroll" { next }
$2!=""  { printf "%s^%s\n",$1,substr($0,length($1)+2) } ' $T > $T1
clientes=./tmp/clientes
./appl/sh/clientes  > $clientes


# |  1 H00 registe 005 015   0 | 2 H01 rutclie 013 000   5 | 3 H02 cliente 020 000  18 | 4 H03 razonso 050 000  38 | 5 H04 giro    050 000  88 |
# |  6 H05 direcci 060 000 138 | 7 H06 region  002 051 198 | 8 H07 comuna  030 002 200 | 9 H08 ciudad  030 000 230 |10 H09 zonarut 002 015 260 |
# | 11 H10 telefon 030 000 262 |12 H11 website 030 000 292 |13 H12 mailemp 030 000 322 |14 H13 contact 030 000 352 |15 H14 mailcon 030 000 382 |
# | 16 H15 observa 256 011 412 |17 H16 status  002 053 668 |18 H17 creatio 010 008 670 |

documentosventa=./tmp/documentosventa
./appl/sh/documentosventa > $documentosventa

# |  1 H00 registe 004 015   0 | 2 H01 codigo  003 000   4 | 3 H02 identif 030 000   7 | 4 H03 creatio 010 008  37 |

productos=./tmp/productos
./appl/sh/productos > $productos

# |  1 H00 intern  006 015   0 | 2 H01 codbar  015 000   6 | 3 H02 codig   012 000  21 | 4 H03 descri  040 000  33 | 5 H04 descrc  025 000  73 |
# |  6 H05 grupo   002 051  98 | 7 H06 sgrupo  002 052 100 | 8 H07 unidvt  002 053 102 | 9 H08 provee  006 054 104 |10 H09 provee  006 055 110 |
# | 11 H10 precv1  010 001 116 |12 H11 moneda  010 001 126 |13 H12 unidsst 010 015 136 |14 H13 valorst 012 015 146 |15 H14 minimo  010 001 158 |
# | 16 H15 critic  010 001 168 |17 H16 status  002 056 178 |
salecondition=./tmp/salecondition
./appl/sh/salecondition > $salecondition

documenttype=./tmp/documenttype
./appl/sh/documenttype > $documenttype

# |  1 H00 registe 004 015   0 | 2 H01 codigo  003 000   4 | 3 H02 identif 030 000   7 | 4 H03 creatio 010 008  37 |

# |  1 H00 registe 002 015   0 | 2 H01 codigo  002 000   2 | 3 H02 identif 030 000   4 | 4 H03 descrip 040 000  34 | 5 H04 creatio 010 008  74 |
awk -F^ ' BEGIN { ref=0;det=0}
function trail(txt) { while (substr(txt,length(txt),1)==" ") txt=substr(txt,1,length(txt)-1); return (txt) }
function sacap(txt) { tx="";for (i=1;i<=length(txt);i++) if(substr(txt,i,1)!=".")tx=tx""substr(txt,i,1) ; return (tx) }
FILENAME==ARGV[1] { td[$1]=trail($2);next }
FILENAME==ARGV[2] { ru[$1]=trail($2);rs[$1]=trail($4);gi[$1]=trail($5);di[$1]=trail($6);co[$1]=trail($8);ci[$1]=trail($9); next }
FILENAME==ARGV[3] { cv[$1]=trail($2);dcv[$1]=trail($3);next }
FILENAME==ARGV[4] { cd[$1]=trail($3);ds[$1]=trail($4);un[$1]=trail(substr($8,4)); next }
FILENAME==ARGV[5] { dt[$1]=trail($2); next }
/H01/ { printf "%s^%s\n","Folio",$2;folio=$2 } 
/H07/ { printf "%s^%s\n","FchEmis",$2 } 
/H03/ { printf "%s^%s\n","TipoDTE",td[$2];tipo=td[$2] } 
/H04/ { 
printf "%s^%s\n","RUTRecep",sacap(trail(ru[$2]))
printf "%s^%s\n","RUTReceptor",sacap(trail(ru[$2]))
printf "%s^%s\n","RznSocRecep",rs[$2]
printf "%s^%s\n","GiroRecep",gi[$2]
printf "%s^%s\n","DirRecep",di[$2]
printf "%s^%s\n","CmnaRecep",co[$2]
printf "%s^%s\n","CiudadRecep",ci[$2]
}
/H06/ { if(cv[$2] >50) fp=1
else fp=0
printf "%s^%s\n","FmaPago",fp 
printf "%s^%s\n","FormmaPago",dcv[$2] }
/H07/ { printf "%s^%s\n","FchVenc",$2 } 
/D..00/{
ind=substr($1,length($1)-3,2)+1

printf "%s%.2d^%d\n","NroLinDet",ind,ind
printf "%s%.2d^%s\n","TpoCodigo",ind,"ALFA0"
printf "%s%.2d^%s\n","VlrCodigo",ind,cd[$2]
if($2!="000000") printf "%s%.2d^%s\n","NmbItem",ind,ds[$2]
printf "%s%.2d^%s\n","UnmdItem",ind,un[$2]
}
/D..03/{
ind=substr($1,length($1)-3,2)+1 
printf "%s%.2d^%s\n","NmbItem",ind,$2
}
/D..04/{
ind=substr($1,length($1)-3,2)+1 
if($2+0) printf "%s%.2d^%s\n","IndExe",ind,$2
}
/D..05/{
ind=substr($1,length($1)-3,2)+1 
printf "%s%.2d^%s\n","PrcItem",ind,$2
}
/D..07/{
ind=substr($1,length($1)-3,2)+1 
printf "%s%.2d^%s\n","QtyItem",ind,$2
}
/D..09/{
ind=substr($1,length($1)-3,2)+1 
printf "%s%.2d^%.0f\n","MontoItem",ind,$2
}
/D..12/{
ind=substr($1,length($1)-3,2)+1 
printf "%s%.2d^%s\n","DescItem",ind,$2
}
$1=="net" { printf "%s^%.0f\n","MntNeto",$2 }
$1=="iva" { printf "%s^%.0f\n","IVA",$2 }
$1=="total" { printf "%s^%.0f\n","MntTotal",$2 }
/H14/ {
	rf=split($2,refr,"|")
	if(rf>1) for (i=1;i<rf;i+=5) if(refr[i+1]!="")
	{
		printf "NroLinRef%.2d^%s\n",++lrf,lrf
		printf "TpoDocRef%.2d^%s\n",lrf,trail(dt[refr[i+1]])
		printf "FolioRef%.2d^%s\n",lrf,trail(refr[i+3])
		printf "FchRef%.2d^%s\n",lrf,trail(refr[i+4])
		printf "RazonRef%.2d^%s\n",lrf,trail(refr[i+5])
	}
}
END {
		printf "Documento^%s\n","DTE"folio"T"tipo
		printf "%s\n","DTE"folio"T"tipo >"'"$T2"'"
		printf "IndRef^%d\n",lrf
		printf "IndDet^%d\n",ind
}


 ' $documentosventa $clientes $salecondition $productos $documenttype $T1 > $ENC

tmst=`date +%Y-%m-%dT%T`

empresa=./tmp/empresa
appl/sh/empresa | awk -F^ '
function sacap(txt) { tx="";for (i=1;i<=length(txt);i++) if(substr(txt,i,1)!=".")tx=tx""substr(txt,i,1) ; return (tx) }
function trail(txt) { while (substr(txt,length(txt),1)==" ") txt=substr(txt,1,length(txt)-1); return (txt) }
{
printf "RUTEmisor^%s\n",sacap(trail($2))
printf "RznSoc^%s\n",trail($4)
printf "GiroEmis^%s\n",trail($5)
printf "Acteco^%s\n",trail($19)
printf "DirOrigen^%s\n",trail($6)
printf "CmnaOrigen^%s\n",trail($8)
printf "CiudadOrigen^%s\n",trail($9)
printf "RutEnvia^%s\n",sacap(trail($23))

printf "TasaIVA^%s\n",trail($20)
printf "FchResol^%s\n",trail($22)
printf "TmstFirmaEnv^%s\n","'"$tmst"'"
printf "NroResol^%s\n",trail($21)

} ' >>$ENC



# |  1 H00 registe 005 015   0 | 2 H01 rutempr 013 000   5 | 3 H02 empresa 020 000  18 | 4 H03 razonso 050 000  38 | 5 H04 giro    050 000  88 |
# |  6 H05 direcci 060 000 138 | 7 H06 region  002 051 198 | 8 H07 comuna  030 002 200 | 9 H08 ciudad  030 000 230 |10 H09 telefon 030 000 260 |
# | 11 H10 website 030 000 290 |12 H11 mailemp 030 000 320 |13 H12 contact 030 000 350 |14 H13 mailcon 030 000 380 |15 H14 observa 512 011 410 |
# | 16 H15 correoa 040 000 922 |17 H16 correoc 040 000 962 |18 H17 correoi 040 000 1002 |19 H18 acteco  007 001 1042 |20 H19 nroreso 003 001 1049 |
# | 21 H20 fechare 010 009 1052 |22 H21 rutfirm 013 007 1062 |23 H22 nombref 040 000 1075 |24 H23 status  002 053 1115 |25 H24 creatio 010 008 1117 |
paramet=`cat $T2`
transfer=../TRANSFER/$paramet
{
./enc.cgi
./det.cgi
./ref.cgi
./ted.cgi
echo "<TmstFirma>"$tmst"</TmstFirma>"
echo "</Documento>"
echo "</DTE>"
} | xmllint --format - >$transfer
echo $paramet
more $transfer
#wget http://sig.homelinux.com/cgi-bin/chilkat/transfer.cgi?$paramet
